/* Elvira Bluetooth FTP 
 * Copyright (C) 2007  Alberto Salas Bragado
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "favorites.h"

int writeFavorites(device_t *favorites, int nfavorites) {

	FILE *file_favorites;

	file_favorites = fopen(FILE_FAVORITES, "wb");

	if (file_favorites != NULL) {

		if (fwrite(favorites, sizeof(device_t), nfavorites, file_favorites)
				!= nfavorites)
			return COP_FF_WRITE;

		fclose(file_favorites);

	} else {

		return COP_FF_OPENW;

	}

	return 0;

}

int loadFavorites(device_t **favorites, int *numfavorites) {

	device_t temp;
	FILE *file_favorites;
	
	*favorites = NULL;
	*numfavorites = 0;

	file_favorites = fopen(FILE_FAVORITES, "rb");

	if (file_favorites != NULL) {

		while (fread(&temp, sizeof(device_t), 1, file_favorites)) {
			
			*numfavorites += 1;

			*favorites = (device_t *) realloc(*favorites, sizeof(device_t)
					*(*numfavorites));
			memcpy((*favorites)+(*numfavorites)-1, &temp, sizeof(temp));

		}

		fclose(file_favorites);

	} else {

		return COP_FF_OPENR;

	}

	return 0;

}
